<bugID>971043<Summary>Implement document walker to grab webpage's text content and format it for translation service</Summary><Description>When a webpage content has finished loading, we need grab all of the page's text content and parse it in a way that is suitable for the translation service.

It must generate a tree similar to a DOM tree, but it must skip non-textual nodes that may exist inside the page's body (such as &lt;script&gt;, &lt;style&gt;, others?).
It also does not need to preserve the whole tree structure, as it can discard any nodes which do not directly have text content.
And it should assign unique ids to each node, which do not need to reflect the ids from the webpage.

For example, the following page:

&lt;html&gt;
&lt;body&gt;
  &lt;h1 id="header" class="h1class"&gt;Welcome to &lt;b&gt;Felipe's&lt;/b&gt; webpage&lt;/h1&gt;
  &lt;div&gt;My Sidebar
    &lt;ul&gt;
      &lt;li&gt;Item 1&lt;/li&gt;
      &lt;li&gt;Item 2&lt;/li&gt;
    &lt;/ul&gt;
  &lt;/div&gt;

  &lt;div class="main-page"&gt;
    &lt;p&gt;This is the main page's body&lt;/p&gt;
  &lt;/div&gt;

  &lt;script&gt;analyticsTracking();&lt;/script&gt;
  &lt;style&gt;div { color: blue }&lt;/style&gt;
&lt;/body&gt;&lt;/html&gt;

Should get a tree (in a JS struct) like:

&lt;body&gt;
  &lt;h1 id="1"&gt;Welcome to &lt;b id="2"&gt;Felipe's&lt;/b&gt;webpage&lt;/h1&gt;
  &lt;div id="3"&gt;
    &lt;li id="4"&gt;Item 1&lt;/li&gt;
    &lt;li id="5"&gt;&lt;/li&gt;
  &lt;div&gt;
  &lt;p id="6"&gt;This is the main page's body&lt;/p&gt;
&lt;/body&gt;


In addition, this module needs to be able to parse a string serialization of this structure (as above) back into an equal JS struct.</Description></bugID>